-- fsource = GetOpenFileName \
-- caption:"KOF Unpacker / Decompressor" types: \
-- "PAK(*pak)|*.pak|All files (*.*)|*.*|"
-- f= 			fopen fsource "rb"
-- fext= 		getFilenameType fsource
-- fsize= 		getFileSize fsource
-- fpath= 	getFilenamePath fsource
-- fname= 	getFilenameFile fsource

f = fopen "T:\\Projects\\Hacking Projects\\Fatal Frame Project Zero\\new\\MDL's\\M056_MINDEAD\\M056_MINDEAD_0001\\M056_MINDEAD_0001_0004.dat" "rb"
fpath="T:\\Projects\\Hacking Projects\\Fatal Frame Project Zero\\new\\MDL's\\M056_MINDEAD.MDL\\"

fn ReadFixedString bstream fixedLen = (
	local str = ""
	for i = 1 to fixedLen do
	(
		str += bit.intAsChar (ReadByte bstream #unsigned)
	)
	str
)



FileID=readlong f #unsigned
fseek f -4 #seek_cur

if FileID==0x00001050 do( --model data
getPos=ftell f
FileID=readlong f #unsigned
pad=readshort f #unsigned
matCount=readshort f #unsigned
pad=readlong f #unsigned
mdlHeaderLEN=readlong f #unsigned+getPos
MatSectionLEN=readlong f #unsigned+getPos
uknCount=readlong f #unsigned

-- lots of data here? positioning data? / skipping for now...

fseek f mdlHeaderLEN #seek_set -- jump to material data
matArray=#()
for x=1 to  matCount do(
typeID=readlong f #unsigned --1
texName=readstring f
matname=readDelimitedString (stringStream texName) "."
append matArray matName
fseek f 160 #seek_cur --skips possible texture properties
)


fseek f MatSectionLEN #seek_set -- jump to Model data

typeID=readlong f #unsigned --3
sectionCount=readlong f #unsigned
vertOffset=readlong f #unsigned+getPos
normOffset=readlong f #unsigned+getPos
vertCount=(normOffset-vertOffset)/16

--==================================
uvwArray=#()
faceArray=#()
vertArray=#()
fseek f vertOffset #seek_set
for x=1 to vertCount do(
vX=readfloat f
vY=readfloat f
vZ=readfloat f--;vZ=-vZ
ukn=readfloat f -- always 1.0?
append vertArray[vX,vY,vZ]
append uvwArray[vX,vY,vZ]
	)
for x=1 to vertCount do(
nX=readfloat f
nY=readfloat f
nZ=readfloat f
ukn=readfloat f -- always 1.0?
	)
typeID=readlong f #unsigned --0x10 Footer Data?
uknCount=readlong f #unsigned
uknOffset=readlong f #unsigned
pad=readlong f #unsigned
--==================================


typeID=readlong f #unsigned --0x90 ?? Pos data???
uknCount=readlong f #unsigned
uknOffset=readlong f #unsigned
pad=readlong f #unsigned
	
for x=1 to uknCount*2 do(
uX=readfloat f
uY=readfloat f
uZ=readfloat f
ukn=readfloat f -- always 1.0?
	)
typeID=readlong f #unsigned --0x10 Footer Data?
uknCount=readlong f #unsigned
uknOffset=readlong f #unsigned
pad=readlong f #unsigned
--==================================

typeID=readlong f #unsigned --0xF0 ?? Face data??? or 0xE0 ??
pad=readlong f #unsigned
ukn1=readshort f #unsigned
ukn2=readshort f #unsigned
faceCount=readshort f #unsigned
ukn3=readshort f #unsigned

fseek f 16 #seek_cur
for x = 1 to (faceCount/3)-2 do (
fa=readlong f #unsigned+1
fb=readlong f #unsigned+1
fc=readlong f #unsigned+1
append faceArray[fa,fb,fc]
)

































msh = mesh vertices:vertArray faces:faceArray   --build mesh
msh.numTVerts = uvwArray.count
buildTVFaces msh
-- for j = 1 to uvwArray.count     do setTVert  msh j uvwArray[j]
-- for j = 1 to faceArray.count   do setTVFace msh j faceArray[j]































	)




























/*
uvwArray=#()
faceArray=#()
vertArray=#()

fseek f 0x1A20 #seek_set


for x=1 to 2386 do(
vX=readfloat f
vY=readfloat f
vZ=readfloat f;vZ=-vZ
ukn=readfloat f -- always 1.0?
append vertArray[vX,vY,vZ]
append uvwArray[vX,vY,vZ]
	)


fa=1
fb=2
fc=3
for x = 1 to vertArray.count / 3 do (
append faceArray[fa,fb,fc]
fa+=3
fb+=3
fc+=3
)


msh = mesh vertices:vertArray faces:faceArray   --build mesh
msh.numTVerts = uvwArray.count
buildTVFaces msh
-- for j = 1 to uvwArray.count     do setTVert  msh j uvwArray[j]
-- for j = 1 to faceArray.count   do setTVFace msh j faceArray[j]






*/












gc()
fclose f